# Module core

The core set of date, time, duration, and interval types, supporting the ISO calendar system..

# Package io.islandtime

Date-time primitives and core concepts, including classes such as `Date`, `Time`, `Instant`, and `ZonedDateTime`.

# Package io.islandtime.base

*(Experimental)* Framework-level interfaces, allowing aspects of date, time, and duration to be abstracted. This area is unstable and likely to see significant change.

# Package io.islandtime.calendar

Platform-independent calendar properties.

# Package io.islandtime.clock

The default clock implementation, providing access to the current system time at up to nanosecond precision when available.

# Package io.islandtime.darwin

Various extensions specific to the Apple platform.

# Package io.islandtime.format

Formatting of dates, times, durations, and intervals into textual representations.

# Package io.islandtime.jvm

Various extensions specific to the Java platform.

# Package io.islandtime.locale

Platform-independent locale.

# Package io.islandtime.measures

Classes related to the measurement of time, including `Duration`, `Period`, and more specific units, such as `IntHours` or `LongYears`.

# Package io.islandtime.parser

Parsing of dates, times, durations, and intervals from textual representations.

# Package io.islandtime.ranges

Date ranges, time intervals, and the ability to iterate over them and perform various operations.

# Package io.islandtime.zone

Provides time zone database access.
